<!DOCTYPE html>
<html>

<head>
  <meta charset='utf-8'>
  <title>Pizza 365 project</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageload()">
  <div class="container">
    <p class="h3 text-center mt-5"> Chọn đồ uống </p>
    <div class="form-group col-12">
      <hr class="mt-5 mb-5" />
    </div>

    <div class="form-group">
      <label>Đồ uống:</label>
      <select class="form-control" id="select-drink">
        <option>Chọn đồ uống</option>
      </select>
    </div>
    <button id="show-result" class="btn btn-primary w-25" onclick="onBtnHienThiClick()">Hiển thị</button>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageload() {
      // b1: Đọc dữ liệu(không có)
      // b2: kiểm tra dữ liệu(không có)
      // b3: Gọi sever
      var vXmlHttp = new XMLHttpRequest();
      callApiGetDrinkData(vXmlHttp);
      vXmlHttp.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            // b4: xử lý hiển thị
            handlersLoadDataToSelectDrink(vXmlHttp)
          }
        };
    }

    function onBtnHienThiClick() {
      var vDrinkList = {
        drinkValue: "",
        drinkText: ""
      }
      // B1: Thu thập dữ liệu
      getDrinkData(vDrinkList);
      // B2: Kiểm tra dữ liệu (bỏ qua)
      // B3: Hiển thị dữ liệu
      showDrinkToConsole(vDrinkList);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu đồ uống
    function getDrinkData(paramDrink) {
      var vDrinkSelect = document.getElementById("select-drink");
      paramDrink.drinkValue = vDrinkSelect.value;
      paramDrink.drinkText = vDrinkSelect.options[vDrinkSelect.selectedIndex].text;
    }

    // Hàm hiển thị dữ liệu đồ uống
    function showDrinkToConsole(paramDrink) {
      console.log(paramDrink);
    }

    // Gọi sever
    function callApiGetDrinkData(paramXhttp) {
      "use strict";
      paramXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      paramXhttp.send();
    }

    // hiển thị dữ liệu
    function handlersLoadDataToSelectDrink(paramXhttp) {
      "use strict";
      console.log(paramXhttp.responseText); // hiển thị responseText ra console
      // parsing dữ liệu thành object
      var vDrinkList = JSON.parse(paramXhttp.responseText);
      // load data to drink select
      var vElementDrinkSelect = document.getElementById("select-drink");
      for (var bI = 0; bI < vDrinkList.length; bI++) {
        var vSelect = document.createElement('option');
        vSelect.value = vDrinkList[bI].maNuocUong;
        vSelect.text = vDrinkList[bI].tenNuocUong;
        vElementDrinkSelect.appendChild(vSelect);
      }
    }

    //mã nguồn để load data về
    function sampleCodeLoadData() {
      var vXmlHttp = new XMLHttpRequest();
      vXmlHttp.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(vXmlHttp.responseText); //ghi response text ra console.log
          }
        };
        vXmlHttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
        vXmlHttp.send();
    }

  </script>
</body>

</html>